/* Relocate a TRS-80 program */

#include <stdio.h>
#include <stdlib.h>

#define EXIT(s) exit(fprintf(stderr,"%s\n",s))

unsigned char bCode[32768];

void main(int argc,char *argv[])
{
unsigned int nOffset,nLine,nPtr,nStart,n,nAddr,nRead;
FILE *f = fopen(argv[1],"rb");
printf("Converting %s to %s.\n",argv[1],argv[2]);
if (f == NULL) EXIT("Can't open input file");
nRead = fread(bCode,1,32768,f);
fclose(f);
if (bCode[0] != 0xFF) EXIT("Not a TRS80 basic program");

nStart = 1;
while (nOffset = bCode[nStart] | (bCode[nStart+1] << 8),nOffset != 0)
	{
	/* Get the line number */
	nLine = bCode[nStart+2] | (bCode[nStart+3] << 8);
	/* Look for the end of line marker */
	nPtr = nStart+4;
	while (bCode[nPtr] != 0) nPtr++;
	nPtr++;
	/* nPtr points to next line */
	printf("Found %5d. Length %4d\n",nLine,nPtr-nStart);
	/* Calculate the address 42e9+nAddr */
	nAddr = nPtr - 1 + 17129;
	/* Patch the address */
	bCode[nStart] = nAddr & 0xFF;
	bCode[nStart+1] = nAddr >> 8;
	nStart = nPtr;
	}
nStart = nStart+2;
f = fopen(argv[2],"wb");
if (f == NULL) EXIT("can't open target file.");
n = fwrite(bCode+1,1,nRead-1,f);
fclose(f);
if (n != nRead-1) EXIT("Write failed.");
}