/***************************/
/* Make vectors for tables */
/***************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

typedef struct _vectable
{
unsigned char bFound[256];
} VEC;

VEC vMain,vCB,vED,vX,vY;

void ClearVec(VEC *v)
{
int i;
for (i = 0;i < 256;i++) v->bFound[i] = 0;
}

void OutVec(VEC *v,char *szLabel,char cExt,char cGrp)
{
int i;
printf("\n%s:\n",szLabel);
for (i = 0;i < 256;i++)
	{
	if (i % 8 == 0) printf("    dw ");
	if (v->bFound[i])
		printf("_%c%c%02x",cGrp,cExt,i);
	else
		printf("_____");
	if (i % 8 == 7) printf("\n"); else printf(",");
	}
}

#define ISCODE(c) ((c) == '_' || toupper(c) == 'C' || toupper(c) == 'E')
#define ISGRP(c) ((c) == '_' || toupper(c) == 'X' || toupper(c) == 'Y' || toupper(c) == 'R')

void main(int argc,char *argv[])
{
int i,n;
char c;
FILE *f;
char szLine[256];

ClearVec(&vMain);
ClearVec(&vCB);
ClearVec(&vED);
ClearVec(&vX);
ClearVec(&vY);

for (i = 1;i < argc;i++)
	{
	f = fopen(argv[i],"r");
	if (f == NULL) exit(fprintf(stderr,"Couldn't open %s.\n",argv[i]));
	while (fgets(szLine,255,f) != NULL)
		{
		if (szLine[0] == '_' &&
			ISGRP(szLine[1]) &&
			ISCODE(szLine[2]) &&
			isxdigit(szLine[3]) &&
			isxdigit(szLine[4]) &&
			szLine[5] == ':')
				{
				c = tolower(szLine[2]);
				sscanf(szLine+3,"%x",&n);
				if (szLine[1] == '_')
					{
					switch(toupper(c))
						{
						case	'_':    vMain.bFound[n] = 1;break;
						case 	'C':    vCB.bFound[n] = 1;break;
						case	'E':	vED.bFound[n] = 1;break;
						}
					}
				else
					{
					if (toupper(szLine[1]) == 'X')
										vX.bFound[n] = 1;
					else
										vY.bFound[n] = 1;
					}
				}
		}
	fclose(f);
	}

OutVec(&vMain,"VecZ80",'_','_');
OutVec(&vCB,"VecZ80CB",'C','_');
OutVec(&vED,"VecZ80ED",'E','_');
OutVec(&vX,"VecZ80DD",'_','X');
OutVec(&vX,"VecZ80FD",'_','Y');

for (n = 0; n < 256;n++)
	if ((n % 8) != 6) vCB.bFound[n] = 0;

OutVec(&vCB,"VecZ80xCB",'C','_');
}

